<template>
  <div class="auth-page">
    <div class="logo">
      <!-- <img src="https://placehold.co/48x48?text=%3E_" /> -->
      <div class="placeholder-logo">&nbsp;</div>
      <div class="logo-text">
        <span class="indent">Indent</span><span class="dot">.</span><span class="cloud">Cloud</span>
      </div>
    </div>

    <div id="central-card-form">
      <div class="outer">
        <div class="middle">
          <h2>Create a new account</h2>
          <Card dis-hover>
            <Form ref="registerForm" :model="registerForm" :rules="registerFormRules" >
              <FormItem label="Username" prop="username">
                <Input type="text" v-model="registerForm.username" />
              </FormItem>
              <FormItem label="Email" prop="email">
                <Input type="email" v-model="registerForm.email" />
              </FormItem>
              <FormItem label="Password" prop="password">
                  <Input type="password" v-model="registerForm.password" />
              </FormItem>
              <FormItem label="Confirm your Password" prop="passwordConfirm">
                  <Input type="password" v-model="registerForm.passwordConfirm" />
              </FormItem>
              
              <FormItem>
                <Button type="success" @click="handleSubmit('registerForm')">Regsiter</Button>
              </FormItem>

              <div id="additional-links">
                <router-link to="/login">Cancel</router-link>
              </div>
            </Form>
          </Card>
        </div>
      </div>
    </div>
  </div>
</template>

<script>
  export default {
    data () {
      const validateEmpty = (rule, value, callback) => {
        if (value === '') {
          callback(new Error('Please fill in this field'));
        } else {
          callback();
        }
      };
      const validatePassword = (rule, value, callback) => {
        if (this.registerForm.passwordConfirm !== '') {
          this.$refs.registerForm.validateField('passwordConfirm');
        }
        callback();
      };
      const validatePasswordConfirm = (rule, value, callback) => {
        if (value !== this.registerForm.password) {
          callback(new Error('Password does not match'));
        } else {
          callback();
        }
      };
      
      return {
        registerForm: {
          username: '',
          email: '',
          password: '',
          passwordConfirm: ''
        },
        registerFormRules: {
          username: [
            { validator: validateEmpty, trigger: 'blur' }
          ],
          email: [
            { validator: validateEmpty, trigger: 'blur' }
          ],
          password: [
            { validator: validateEmpty, trigger: 'blur' },
            { validator: validatePassword, trigger: 'blur' }
          ],
          passwordConfirm: [
            { validator: validateEmpty, trigger: 'blur' },
            { validator: validatePasswordConfirm, trigger: 'blur' }
          ]
        }
      }
    },
    methods: {
      handleSubmit (name) {
        this.$refs[name].validate((valid) => {
          if (valid) {
            this.$Message.success('Success!');
          } else {
            this.$Message.error('Fail!');
          }
        })
      }
    }
  }
</script>

<style lang="scss">
  @import '@/assets/scss/central-card-form.scss';
</style>